def addthree(x):
  return x + 3

def clearRed(pic):
  for p in getPixels(pic):
    redvalue = 0
    setRed(p, redvalue)

def clearGreen(pic):
  for p in getPixels(pic):
    greenvalue = 0
    setGreen(p, greenvalue)

def clearBlue(pic):
  for p in getPixels(pic):
    bluevalue = 0
    setBlue(p, bluevalue)

def grayscale(pic):
  for p in getPixels(pic):
    redvalue = getRed(p)
    greenvalue =  getGreen(p)
    bluevalue = getBlue(p)

    grayvalue = (redvalue + greenvalue + bluevalue) / 3
    setRed(p, grayvalue)
    setGreen (p, grayvalue)
    setBlue(p, grayvalue)

def clearGreen(flower):
  for p in getPixels(flower):
    greenvalue = 0
    setGreen(p, greenvalue)

# if the red is too high, make it 0.
def flopRed(swan):
  for p in getPixels(swan):
    r = getRed(p)
    mycolor = getColor(p)
    dist = distance(mycolor, green)

    if (dist < 0):
      setColor(p, pink)

    if (r > 100):
      setRed(p,0)

def negative(eiffel):
  for p in getPixels(eiffel):
    redvalue = getRed(p)
    rednegative = (255 - redvalue)
    greenvalue = getGreen(p)
    greennegative = (255 - greenvalue)
    bluevalue = getBlue(p)
    bluenegative = (255 - bluevalue)
    setRed(p, rednegative)
    setGreen(p, greennegative)
    setBlue(p, bluenegative)

# is a little note
# types of changes: clear a color, negative, grayscale, darken, lighten, spincolors, mirror, posterize


#To load Pictures:
# fn = pickAFile(fn)
# pic = makePicture(fn)
# show(pic)

def lighten(garden):
  for p in getPixels(garden):
    redvalue = getRed(p)
    greenvalue = getGreen(p)
    bluevalue = getBlue(p)
    lightenredvalue = (redvalue * 1.5)
    lightengreenvalue = (greenvalue * 1.5)
    lightenbluevalue = (bluevalue * 1.5)
    setRed(p, lightenredvalue)
    setBlue(p, lightenbluevalue)
    setGreen(p, lightengreenvalue)

def darken(arch):
  for p in getPixels(arch):
    redvalue = getRed(p)
    greenvalue = getGreen(p)
    bluevalue = getBlue(p)
    darkblue = (bluevalue * 0.5)
    darkred = (redvalue * 0.5)
    darkgreen = (greenvalue * 0.5)
    setRed(p, darkred)
    setGreen(p, darkgreen)
    setBlue(p, darkblue)


def spincolors(pic):
  for p in getPixels(pic):
    redvalue = getRed(p)
    greenvalue = getGreen(p)
    bluevalue = getBlue(p)
    setRed(p, greenvalue)
    setGreen(p, bluevalue)
    setBlue(p,redvalue)

def spincolors2(pic):
  for p in getPixels(pic):
    redvalue = getRed(p)
    greenvalue = getGreen(p)
    bluevalue = getBlue(p)
    setRed(p, bluevalue)
    setGreen(p, redvalue)
    setBlue(p, greenvalue)

#Spincolors 1 and 2 undo each other


# examples of loops:
def forloopexample(thelist):
  for thing in thelist:
    print "this thing is", thing

def forloopexampl2(thelist):
  total = 0
  for ting in thelist:
    total = total + thing

  print total

# to save Pictures:
# setMediaPath()
# writePictureTo(pic, "awesome.jpg")


def mirrorHorizontal(canvas):
  mirrorPoint = getHeight(canvas)/2
  for y in range(1,mirrorPoint):
    for x in range(1, getWidth(canvas)):
      mirrorTo = getPixel(canvas, x, y+mirrorPoint)
      mirrorFrom=getPixel(canvas,x,mirrorPoint-y)
      setColor(mirrorTo, getColor(mirrorFrom))

def mirrorVertical(source):
  mirrorpoint=int(getWidth(source)/2)
  for y in range(1,getHeight(source)):
    for x in range(1,mirrorpoint):
      p = getPixel(source,x+mirrorpoint,y)
      p2 =  getPixel(source, mirrorpoint-x,y)
      c = getColor(p2)
      setColor(p,c)


#to find a color:  pickAColor()


#To make a picture use only 3 colors:
#Code for blue, pink and black posterizing:
def posterizepinkblue(pic):
  mydarkblue = makeColor(0, 51, 153)
  for p in getPixels(pic):
    distblue = distance(getColor(p), mydarkblue)
    distpink = distance(getColor(p), pink)
    distblack = distance(getColor(p), black)
    if(min(distblue,distpink,distblack) == distblue):
      setColor(p, mydarkblue)
    if(min(distblue, distpink, distblack) == distpink):
      setColor(p, pink)
    if(min(distblue, distpink, distblack) == distblack):
      setColor(p, black)

def posterizeyellowblue(pic):
  for p in getPixels(pic):
    distblue = distance(getColor(p), blue)
    distyellow = distance(getColor(p), yellow)
    distblack = distance(getColor(p), black)
    if(min(distblue,distyellow,distblack) == distblue):
      setColor(p, blue)
    if(min(distblue,distyellow, distblack) == distyellow):
      setColor(p, yellow)
    if(min(distblue,distyellow,distblack) == distblack):
      setColor(p, black)

def posterizegreenbluered(pic):
  for p in getPixels(pic):
    distgreen = distance(getColor(p), green)
    distblue = distance(getColor(p), blue)
    distred = distance(getColor(p), red)
    if(min(distgreen,distblue,distred) == distgreen):
      setColor(p,green)
    if(min(distgreen,distblue,distred) == distblue):
      setColor(p,blue)
    if(min(distgreen,distblue,distred) == distred):
      setColor(p,red)

def posterizeorangewhiteblueblackmypink(pic):
  mypink =makeColor(201,175,221)
  for p in getPixels(pic):
    distorange = distance(getColor(p), orange)
    distwhite = distance(getColor(p), white)
    distblue = distance(getColor(p), blue)
    distblack = distance(getColor(p), black)
    distmypink = distance(getColor(p), mypink)
    if(min(distorange,distwhite,distblue,distblack,distmypink) == distorange):
      setColor(p, orange)
    if(min(distorange,distwhite,distblue,distblack,distmypink) == distwhite):
      setColor(p, white)
    if(min(distorange,distwhite,distblue,distblack,distmypink) == distblue):
      setColor(p, blue)
    if(min(distorange,distwhite,distblue,distblack,distmypink) == distblack):
      setColor(p, black)
    if(min(distorange,distwhite,distblue,distblack,distmypink) == distmypink):
      setColor(p, mypink)

#This function copies a picture onto a canvas, without changing its size.
def copyPicture2(sourcePic,canvas,startX, startY):
# Input parameters are source picture, target picture
# target (X,Y) pixel location
  # Now do the actual copying
  targetX = startX
  for sourceX in range (1, getWidth(sourcePic)):
    targetY=startY
    for sourceY in range (1,getHeight(sourcePic)):
      color = getColor(getPixel(sourcePic,sourceX,sourceY))
      if(targetX < getWidth(canvas) and targetY < getHeight(canvas)):
        setColor(getPixel(canvas,targetX,targetY),color)
      targetY=targetY + 1
    targetX= targetX+1
  show(sourcePic)
  show(canvas)
  return canvas

#Chromakey, replace all green with new background
def chromakey(source,bg):
  # source should have something in front of green, bg is new background
  for x in range(1,getWidth(source)):
    for y in range(1,getHeight(source)):
      p=getPixel(source,x,y)
      # My definition of green: if red+blue < green
      if (getRed(p) + getBlue(p) < 1.5* getGreen(p)):
      #Then grab the color at same spot from new background
       setColor(p,getColor(getPixel(bg,x,y)))
  return source

#The following function can be edited to shrink pictures to a fraction of their original size
#Here is a function that copies a picture onto a canvas while making it 1/4 its original size.
def copy4TimesSmaller(picture,canvas,startX,startY):
  targetX=startX
  targetY=startY
  sourceX=1
  for x in range(targetX,targetX+getWidth(picture)/4):
    sourceY=1
    for y in range(targetY,targetY+getHeight(picture)/4):
      print x,y
      color=getColor(getPixel(picture,sourceX,sourceY))
      setColor(getPixel(canvas,x,y),color)
      #everytime we add a pixel to the canvas, we skip 3 in the original picture
      sourceY=sourceY+4
    sourceX=sourceX+4
  show(picture)
  show(canvas)
  return canvas